Package com.google.android.exoplayer2.trackselection

## Class AdaptiveTrackSelection

- java.lang.Object
- - com.google.android.exoplayer2.trackselection.BaseTrackSelection
  - - com.google.android.exoplayer2.trackselection.AdaptiveTrackSelection

- All Implemented Interfaces:
    `ExoTrackSelection`, `TrackSelection`

      public class AdaptiveTrackSelection
      extends BaseTrackSelection

  A bandwidth based adaptive `ExoTrackSelection`, whose selected track is updated to be the one of highest quality given the current network conditions and the state of the buffer.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `AdaptiveTrackSelection.AdaptationCheckpoint` | Checkpoint to determine allocated bandwidth.
    `static class` | `AdaptiveTrackSelection.Factory` | Factory for `AdaptiveTrackSelection` instances.

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.trackselection.ExoTrackSelection

      `ExoTrackSelection.Definition`

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.trackselection.TrackSelection

      `TrackSelection.Type`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static float` | `DEFAULT_BANDWIDTH_FRACTION` |
    `static float` | `DEFAULT_BUFFERED_FRACTION_TO_LIVE_EDGE_FOR_QUALITY_INCREASE` |
    `static int` | `DEFAULT_MAX_DURATION_FOR_QUALITY_DECREASE_MS` |
    `static int` | `DEFAULT_MAX_HEIGHT_TO_DISCARD` |
    `static int` | `DEFAULT_MAX_WIDTH_TO_DISCARD` |
    `static int` | `DEFAULT_MIN_DURATION_FOR_QUALITY_INCREASE_MS` |
    `static int` | `DEFAULT_MIN_DURATION_TO_RETAIN_AFTER_DISCARD_MS` |

    - ### Fields inherited from class com.google.android.exoplayer2.trackselection.BaseTrackSelection

      `group, length, tracks`

    - ### Fields inherited from interface com.google.android.exoplayer2.trackselection.TrackSelection

      `TYPE_CUSTOM_BASE, TYPE_UNSET`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AdaptiveTrackSelection​(TrackGroup group, int[] tracks, @com.google.android.exoplayer2.trackselection.TrackSelection.Type int type, BandwidthMeter bandwidthMeter, long minDurationForQualityIncreaseMs, long maxDurationForQualityDecreaseMs, long minDurationToRetainAfterDiscardMs, int maxWidthToDiscard, int maxHeightToDiscard, float bandwidthFraction, float bufferedFractionToLiveEdgeForQualityIncrease, List<AdaptiveTrackSelection.AdaptationCheckpoint> adaptationCheckpoints, Clock clock)` |
    `` | `AdaptiveTrackSelection​(TrackGroup group, int[] tracks, BandwidthMeter bandwidthMeter)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected boolean` | `canSelectFormat​(Format format, int trackBitrate, long effectiveBitrate)` | Called when updating the selected track to determine whether a candidate track can be selected.
    `void` | `disable()` | Disables this track selection.
    `void` | `enable()` | Enables the track selection.
    `int` | `evaluateQueueSize​(long playbackPositionUs, List<? extends MediaChunk> queue)` | Returns the number of chunks that should be retained in the queue.
    `protected long` | `getMinDurationToRetainAfterDiscardUs()` | Called from `evaluateQueueSize(long, List)` to determine the minimum duration of buffer to retain after discarding chunks.
    `int` | `getSelectedIndex()` | Returns the index of the selected track.
    `Object` | `getSelectionData()` | Returns optional data associated with the current track selection.
    `@com.google.android.exoplayer2.C.SelectionReason int` | `getSelectionReason()` | Returns the reason for the current track selection.
    `void` | `onPlaybackSpeed​(float playbackSpeed)` | Called to notify the selection of the current playback speed.
    `protected boolean` | `shouldEvaluateQueueSize​(long nowMs, List<? extends MediaChunk> queue)` | Called from `evaluateQueueSize(long, List)` to determine whether an evaluation should be performed.
    `void` | `updateSelectedTrack​(long playbackPositionUs, long bufferedDurationUs, long availableDurationUs, List<? extends MediaChunk> queue, MediaChunkIterator[] mediaChunkIterators)` | Updates the selected track for sources that load media in discrete `MediaChunk`s.

    - ### Methods inherited from class com.google.android.exoplayer2.trackselection.BaseTrackSelection

      `blacklist, equals, getFormat, getIndexInTrackGroup, getSelectedFormat, getSelectedIndexInTrackGroup, getTrackGroup, getType, hashCode, indexOf, indexOf, isBlacklisted, length`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.android.exoplayer2.trackselection.ExoTrackSelection

      `onDiscontinuity, onPlayWhenReadyChanged, onRebuffer, shouldCancelChunkLoad`

- - ### Field Detail

    - #### DEFAULT_MIN_DURATION_FOR_QUALITY_INCREASE_MS

          public static final int DEFAULT_MIN_DURATION_FOR_QUALITY_INCREASE_MS

      See Also:
        Constant Field Values

    - #### DEFAULT_MAX_DURATION_FOR_QUALITY_DECREASE_MS

          public static final int DEFAULT_MAX_DURATION_FOR_QUALITY_DECREASE_MS

      See Also:
        Constant Field Values

    - #### DEFAULT_MIN_DURATION_TO_RETAIN_AFTER_DISCARD_MS

          public static final int DEFAULT_MIN_DURATION_TO_RETAIN_AFTER_DISCARD_MS

      See Also:
        Constant Field Values

    - #### DEFAULT_MAX_WIDTH_TO_DISCARD

          public static final int DEFAULT_MAX_WIDTH_TO_DISCARD

      See Also:
        Constant Field Values

    - #### DEFAULT_MAX_HEIGHT_TO_DISCARD

          public static final int DEFAULT_MAX_HEIGHT_TO_DISCARD

      See Also:
        Constant Field Values

    - #### DEFAULT_BANDWIDTH_FRACTION

          public static final float DEFAULT_BANDWIDTH_FRACTION

      See Also:
        Constant Field Values

    - #### DEFAULT_BUFFERED_FRACTION_TO_LIVE_EDGE_FOR_QUALITY_INCREASE

          public static final float DEFAULT_BUFFERED_FRACTION_TO_LIVE_EDGE_FOR_QUALITY_INCREASE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AdaptiveTrackSelection

          public AdaptiveTrackSelection​(TrackGroup group,
                                        int[] tracks,
                                        BandwidthMeter bandwidthMeter)

      Parameters:
        `group` - The `TrackGroup`.
        `tracks` - The indices of the selected tracks within the `TrackGroup`. Must not be empty. May be in any order.
        `bandwidthMeter` - Provides an estimate of the currently available bandwidth.

    - #### AdaptiveTrackSelection

          protected AdaptiveTrackSelection​(TrackGroup group,
                                           int[] tracks,
                                           @com.google.android.exoplayer2.trackselection.TrackSelection.Type int type,
                                           BandwidthMeter bandwidthMeter,
                                           long minDurationForQualityIncreaseMs,
                                           long maxDurationForQualityDecreaseMs,
                                           long minDurationToRetainAfterDiscardMs,
                                           int maxWidthToDiscard,
                                           int maxHeightToDiscard,
                                           float bandwidthFraction,
                                           float bufferedFractionToLiveEdgeForQualityIncrease,
                                           List<AdaptiveTrackSelection.AdaptationCheckpoint> adaptationCheckpoints,
                                           Clock clock)

      Parameters:
        `group` - The `TrackGroup`.
        `tracks` - The indices of the selected tracks within the `TrackGroup`. Must not be empty. May be in any order.
        `type` - The type that will be returned from `TrackSelection.getType()`.
        `bandwidthMeter` - Provides an estimate of the currently available bandwidth.
        `minDurationForQualityIncreaseMs` - The minimum duration of buffered data required for the selected track to switch to one of higher quality.
        `maxDurationForQualityDecreaseMs` - The maximum duration of buffered data required for the selected track to switch to one of lower quality.
        `minDurationToRetainAfterDiscardMs` - When switching to a video track of higher quality, the selection may indicate that media already buffered at the lower quality can be discarded to speed up the switch. This is the minimum duration of media that must be retained at the lower quality. It must be at least `minDurationForQualityIncreaseMs`.
        `maxWidthToDiscard` - The maximum video width that the selector may discard from the buffer to speed up switching to a higher quality.
        `maxHeightToDiscard` - The maximum video height that the selector may discard from the buffer to speed up switching to a higher quality.
        `bandwidthFraction` - The fraction of the available bandwidth that the selection should consider available for use. Setting to a value less than 1 is recommended to account for inaccuracies in the bandwidth estimator.
        `bufferedFractionToLiveEdgeForQualityIncrease` - For live streaming, the fraction of the duration from current playback position to the live edge that has to be buffered before the selected track can be switched to one of higher quality. This parameter is only applied when the playback position is closer to the live edge than `minDurationForQualityIncreaseMs`, which would otherwise prevent switching to a higher quality from happening.
        `adaptationCheckpoints` - The `checkpoints` that can be used to calculate available bandwidth for this selection.
        `clock` - The `Clock`.

  - ### Method Detail

    - #### enable

          @CallSuper
          public void enable()

      Description copied from interface: `ExoTrackSelection`
      Enables the track selection. Dynamic changes via `ExoTrackSelection.updateSelectedTrack(long, long, long, List, MediaChunkIterator[])`, `ExoTrackSelection.evaluateQueueSize(long, List)` or `ExoTrackSelection.shouldCancelChunkLoad(long, Chunk, List)` will only happen after this call.

      This method may not be called when the track selection is already enabled.

      Specified by:
        `enable` in interface `ExoTrackSelection`
      Overrides:
        `enable` in class `BaseTrackSelection`

    - #### disable

          @CallSuper
          public void disable()

      Description copied from interface: `ExoTrackSelection`
      Disables this track selection. No further dynamic changes via `ExoTrackSelection.updateSelectedTrack(long, long, long, List, MediaChunkIterator[])`, `ExoTrackSelection.evaluateQueueSize(long, List)` or `ExoTrackSelection.shouldCancelChunkLoad(long, Chunk, List)` will happen after this call.

      This method may only be called when the track selection is already enabled.

      Specified by:
        `disable` in interface `ExoTrackSelection`
      Overrides:
        `disable` in class `BaseTrackSelection`

    - #### onPlaybackSpeed

          public void onPlaybackSpeed​(float playbackSpeed)

      Description copied from interface: `ExoTrackSelection`
      Called to notify the selection of the current playback speed. The playback speed may affect adaptive track selection.
      Specified by:
        `onPlaybackSpeed` in interface `ExoTrackSelection`
      Overrides:
        `onPlaybackSpeed` in class `BaseTrackSelection`
      Parameters:
        `playbackSpeed` - The factor by which playback is sped up.

    - #### updateSelectedTrack

          public void updateSelectedTrack​(long playbackPositionUs,
                                          long bufferedDurationUs,
                                          long availableDurationUs,
                                          List<? extends MediaChunk> queue,
                                          MediaChunkIterator[] mediaChunkIterators)

      Description copied from interface: `ExoTrackSelection`
      Updates the selected track for sources that load media in discrete `MediaChunk`s.

      This method will only be called when the selection is enabled.

      Parameters:
        `playbackPositionUs` - The current playback position in microseconds. If playback of the period to which this track selection belongs has not yet started, the value will be the starting position in the period minus the duration of any media in previous periods still to be played.
        `bufferedDurationUs` - The duration of media currently buffered from the current playback position, in microseconds. Note that the next load position can be calculated as `(playbackPositionUs + bufferedDurationUs)`.
        `availableDurationUs` - The duration of media available for buffering from the current playback position, in microseconds, or `C.TIME_UNSET` if media can be buffered to the end of the current period. Note that if not set to `C.TIME_UNSET`, the position up to which media is available for buffering can be calculated as `(playbackPositionUs + availableDurationUs)`.
        `queue` - The queue of already buffered `MediaChunk`s. Must not be modified.
        `mediaChunkIterators` - An array of `MediaChunkIterator`s providing information about the sequence of upcoming media chunks for each track in the selection. All iterators start from the media chunk which will be loaded next if the respective track is selected. Note that this information may not be available for all tracks, and so some iterators may be empty.

    - #### getSelectedIndex

          public int getSelectedIndex()

      Description copied from interface: `ExoTrackSelection`
      Returns the index of the selected track.

    - #### getSelectionReason

          public @com.google.android.exoplayer2.C.SelectionReason int getSelectionReason()

      Description copied from interface: `ExoTrackSelection`
      Returns the reason for the current track selection.

    - #### getSelectionData

          @Nullable
          public Object getSelectionData()

      Description copied from interface: `ExoTrackSelection`
      Returns optional data associated with the current track selection.

    - #### evaluateQueueSize

          public int evaluateQueueSize​(long playbackPositionUs,
                                       List<? extends MediaChunk> queue)

      Description copied from interface: `ExoTrackSelection`
      Returns the number of chunks that should be retained in the queue.

      May be called by sources that load media in discrete `MediaChunks` and support discarding of buffered chunks.

      To avoid excessive re-buffering, implementations should normally return the size of the queue. An example of a case where a smaller value may be returned is if network conditions have improved dramatically, allowing chunks to be discarded and re-buffered in a track of significantly higher quality. Discarding chunks may allow faster switching to a higher quality track in this case.

      Note that even if the source supports discarding of buffered chunks, the actual number of discarded chunks is not guaranteed. The source will call `ExoTrackSelection.updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` with the updated queue of chunks before loading a new chunk to allow switching to another quality.

      This method will only be called when the selection is enabled and none of the `MediaChunks` in the queue are currently loading.

      Specified by:
        `evaluateQueueSize` in interface `ExoTrackSelection`
      Overrides:
        `evaluateQueueSize` in class `BaseTrackSelection`
      Parameters:
        `playbackPositionUs` - The current playback position in microseconds. If playback of the period to which this track selection belongs has not yet started, the value will be the starting position in the period minus the duration of any media in previous periods still to be played.
        `queue` - The queue of buffered `MediaChunks`. Must not be modified.
      Returns:
        The number of chunks to retain in the queue.

    - #### canSelectFormat

          protected boolean canSelectFormat​(Format format,
                                            int trackBitrate,
                                            long effectiveBitrate)

      Called when updating the selected track to determine whether a candidate track can be selected.
      Parameters:
        `format` - The `Format` of the candidate track.
        `trackBitrate` - The estimated bitrate of the track. May differ from `Format.bitrate` if a more accurate estimate of the current track bitrate is available.
        `effectiveBitrate` - The bitrate available to this selection.
      Returns:
        Whether this `Format` can be selected.

    - #### shouldEvaluateQueueSize

          protected boolean shouldEvaluateQueueSize​(long nowMs,
                                                    List<? extends MediaChunk> queue)

      Called from `evaluateQueueSize(long, List)` to determine whether an evaluation should be performed.
      Parameters:
        `nowMs` - The current value of `Clock.elapsedRealtime()`.
        `queue` - The queue of buffered `MediaChunks`. Must not be modified.
      Returns:
        Whether an evaluation should be performed.

    - #### getMinDurationToRetainAfterDiscardUs

          protected long getMinDurationToRetainAfterDiscardUs()

      Called from `evaluateQueueSize(long, List)` to determine the minimum duration of buffer to retain after discarding chunks.
      Returns:
        The minimum duration of buffer to retain after discarding chunks, in microseconds.